!-----------------------------------------------------------------------
!* This module defines single/double precision parameters and 
!* sets the accuracy of the floating point operations.
!-----------------------------------------------------------------------
module Precision

!-----------------------------------------------------------------------
!* authors:                
!*
!* Alex Ignacio da Silva        ignacioalex@yahoo.com
!* and
!* Sueli M. Viegas              viegas@iagusp.usp.br
!*
!* Instituto Astronomico e Geofisico
!* Universidade de Sao Paulo
!* Av. Miguel Stefano, 4200
!* 04301-904 Sao Paulo - SP
!* Brazil
!*
!* History:
!* Version    Date (D/M/Y)    Comment
!* -------    ------------    -------
!* 1.0        28/04/2000      original code (A.I. Silva)
!-----------------------------------------------------------------------

implicit none

public

! definition of single/double precision parameters:
integer, parameter :: SP = kind (1.0)   ! single precision definition
integer, parameter :: DP = kind (1.0D0) ! double precision definition

! ********************************************
! * precision of floating point calculations *
! ********************************************

! the following corresponds to the old Fortran 77's double precision data type:
integer, parameter :: WP = DP   ! working precision definition

end module Precision
